#!/usr/bin/env bash
{%- for sbatch_option in experiment.sbatch_options %}
#SBATCH {{ sbatch_option }}
{%- endfor %}
set -e

echo $SLURM_ARRAY_TASK_ID

# Fork

mkdir {{ experiment.experiment_scratch_dir }}_$SLURM_ARRAY_TASK_ID
cp -r {{ experiment.experiment_scratch_dir }}/* {{ experiment.experiment_scratch_dir }}_$SLURM_ARRAY_TASK_ID

cp {{ experiment.grid_configs_dir }}/config_$SLURM_ARRAY_TASK_ID {{ experiment.experiment_scratch_dir }}_$SLURM_ARRAY_TASK_ID/

cd {{ experiment.experiment_scratch_dir }}_$SLURM_ARRAY_TASK_ID

{%- if experiment.restore_from_path %}
cp -ru {{ experiment.restore_from_path }} .
{%- endif %}

{%- for module_name in experiment.modules_to_load %}
module load {{ module_name }}
{%- endfor %}
{%- for env_key, env_value in experiment.env.items() %}
export {{ env_key }}={{ env_value }}
{%- endfor %}
{%- if experiment.venv %}
if [ ! -f {{ experiment.venv }}/bin/activate ]; then
    echo "==============================================="
    echo "Virtual env does not exists. Trying to setup"
    echo "Works only with python3"
    python3 -m venv {{ experiment.venv }}
    echo "==============================================="
fi
source {{ experiment.venv }}/bin/activate
{%- if experiment.requirements_file %}
pip install -r {{ experiment.requirements_file }}
{%- endif %}
{%- endif %}
{%- if experiment.conda %}
source activate {{ experiment.conda }}
{%- endif %}
{% set mpi_prefix = 'mpiexec ' if experiment.with_mpi else '' %}
{% set sif_prefix = 'singularity exec %s ' % experiment.singularity_container if experiment.singularity_container else '' %}
export SINGULARITY_PREFIX="{{ sif_prefix }} "
{%- if experiment.prolog_cmd %}
{{ experiment.prolog_cmd }}
{%- endif %}
{{ mpi_prefix }}{{ sif_prefix }}{{ experiment.cmd.command }}

